<?php

namespace Drupal\optimized_assets_proxy;

use Drupal\advagg\Asset\CssOptimizer;

/**
 * Extend CssOptimizer to additionally store data in DB for later.
 */
class AdvaggCssOptimizer extends CssOptimizer {

  /**
   * {@inheritDoc}
   */
  protected function writeFile($data, $cid) {
    $uri = parent::writeFile($data, $cid);
    if ($uri === FALSE) {
      return $uri;
    }

    try {
      $connection = \Drupal::database();
      $connection
        ->insert('optimized_assets_proxy')
        ->fields([
          'file' => basename($uri),
          'data' => $data,
          'timestamp' => \Drupal::time()->getRequestTime(),
        ])
        ->execute();
    }
    catch (\Exception $exception) {
      \Drupal::logger('optimized_assets_proxy')->error($exception->getMessage());
    }

    return $uri;
  }
}
