<?php

namespace Drupal\optimized_assets_proxy;

use Drupal\Core\Asset\AssetDumper as CoreAssetDumper;

/**
 * Extend AssetDumper to additionally store data in DB for later.
 */
class AssetDumper extends CoreAssetDumper {

  /**
   * {@inheritDoc}
   */
  public function dump($data, $file_extension) {
    $uri = parent::dump($data, $file_extension);
    try {
      $connection = \Drupal::database();
      $connection
        ->insert('optimized_assets_proxy')
        ->fields([
          'file' => basename($uri),
          'data' => $data,
          'timestamp' => \Drupal::time()->getRequestTime(),
        ])
        ->execute();
    }
    catch (\Exception $exception) {
      \Drupal::logger('optimized_assets_proxy')->error($exception->getMessage());
    }
    return $uri;
  }

}
